package cz.zweistein.gw.predictor;

import java.util.LinkedList;

import org.apache.log4j.Logger;

public class Predicable {
	private static Logger logger = Logger.getLogger(Predicable.class);
	
	private String name;
	protected LinkedList<Integer> pastOrders;
	private float prediction = -1; // TODO: make it big Float
	private String id;
	
	public String getId() {
		return this.id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public void addOrder(int order) {
		this.pastOrders.addLast(order);
	}
	
	public String getName() {
		return this.name;
	}
	public void setName(String name) {
		this.name = name;
	}
	
	private float getFloatingAverageOrder() {
		if (this.prediction < 0) {
			if (this.pastOrders.size() == 0){
				logger.info(this.getId() + " " + this.getName() + " does not have any past results.");
				// we do not have any past results, lets assume they are bad at GW 
				this.prediction = 16;
				return this.prediction;
			} 
			
			float predictedOrder = this.pastOrders.getFirst();
			
			for (Integer order : this.pastOrders) {
				if (order != null) {
					// skip month without ratings.
					predictedOrder = (predictedOrder + order)/2;
				}
			}
			this.prediction = predictedOrder;
		}
		
		return this.prediction;
	}
	
	public float getPredictedOrder() {
		return this.getFloatingAverageOrder();
	}
}
